#!/usr/bin/python
from ClusterEntity import *
#from xml.dom import minidom

### 9/8/2003 1. changed loglevel default from 4(Warning)
###             to 5(Notice)
MY_INFO = {
   "WHOAMI"  : "clusvcmgrd",

   "OPTIONS" : {
      "loglevel" : { "datatype" : "int",
                     "order"    : 0,
                     "default"  : 5 },
   },

   "ADD_GETOPTS"     : [],

   "UPDATE_GETOPTS"  : [ "clusvcmgrd",
                            "loglevel=" ],

   "DELETE_GETOPTS"  : [],
   "LISTALL_GETOPTS" : [],
}

class clusvcmgrd(ClusterEntity):
   def __init__(self, node):
      ClusterEntity.__init__(self, MY_INFO, node)

   def validate(self, options):

      #######################################################################
      ########################   1. FATAL ERRORS   ##########################
      #######################################################################

      ### 'genericOptionChecks' will raise an error if either the data
      ### doesn't match the datatype(str or int), or the option is
      ### not in the list of valid options for this class.
      ClusterEntity.genericOptionChecks(self, options)

      if options.has_key("loglevel") and options["loglevel"] != "":
         loglevel = options["loglevel"]
         error = FALSE
         try:
            int_loglevel = int(loglevel)
         except:
            error = TRUE
         if not error and \
            (int_loglevel < 0 or int_loglevel > 7):
               error = TRUE
         if error:
            raise OptionError("FATAL",
                              _("""Log Level must be a number from 0 to 7:
  0 - EMERG
  1 - ALERT
  2 - CRIT
  3 - ERR
  4 - WARNING (DEFAULT)
  5 - NOTICE
  6 - INFO
  7 - DEBUG"""),
                              "loglevel",
                              loglevel)

      #######################################################################
      ##########################   2. WARNINGS   ############################
      #######################################################################

      # None
