#!/usr/bin/python
from xml.dom import minidom
from clusterpkg.service_ipaddress_module import service_ipaddress
import clusterpkg.service_ipaddress_module
from ClusterList import *

SERVICE_IPADDRESS_INFO = clusterpkg.service_ipaddress_module.MY_INFO

MY_INFO = {
   "WHOAMI"  : "service_ipaddresses",

   "OPTIONS" : { },

   "ADD_GETOPTS"     : [],
   "DELETE_GETOPTS"  : [],
   "UPDATE_GETOPTS"  : [],
   "LISTALL_GETOPTS" : [ "service=",
                            "device=",
                               "service_ipaddresses" ],
}

class service_ipaddresses(ClusterList):
   def __init__(self, node, parent, action="modify"):
      ClusterList.__init__(self, MY_INFO, node, parent, action)

   def get_list(self):
      nodeList = []
      elements = self.node.getElementsByTagName("service_ipaddress")
      for e in elements:
         nodeList.append(service_ipaddress(e, self))
      return nodeList

   def get_service_ipaddress(self, val, key="ipaddress"):
      search_options = {key : val}
      service_ipaddress_entity = ClusterList.get_child(self, SERVICE_IPADDRESS_INFO, search_options)
      return service_ipaddress(service_ipaddress_entity.node, self)

   def service_ipaddress_found(self, search_options, service_ipaddress_being_validated):
      ### "service_ipaddress_being_validated" is either the service_ipaddress
      ### being modified, or the new service_ipaddress just added.  We want to
      ### be sure his key info doesn't duplicate an existing service_ipaddress.
      return ClusterList.child_found(self, SERVICE_IPADDRESS_INFO, search_options, service_ipaddress_being_validated)

   def add_service_ipaddress(self, cmdline_args):
      entity = ClusterList.add_child(self, SERVICE_IPADDRESS_INFO)
      service_ipaddress_entity = service_ipaddress(entity.node, self, "add")
      service_ipaddress_entity.add_options(cmdline_args)
      return service_ipaddress_entity

   def delete_service_ipaddress(self, ipaddress, cmdline_args):
      search_options = {"ipaddress": ipaddress}
      ClusterList.delete_child(self, SERVICE_IPADDRESS_INFO, search_options, cmdline_args)

   def out(self):
      nodeList = self.node.getElementsByTagName("service_ipaddress")
      for n in nodeList:
         service_ipaddress(n, self).out()
