#!/usr/bin/python

import string, os, fcntl

LOCKFILE_DIR = "/var/run"
 
TRUE = 1
FALSE = 0
 
class lockFileException(Exception):
    def __init__(self, msg):
        self.msg = msg
    def getMessage(self):
        return self.msg

class lockFile:
    "Create a lockFile object for the specified file, and lock the lockfile for exclusive use."
    def __init__(self, lockfile_text_name, lockfile_name):
        self.lockfile_text_name = lockfile_text_name
        self.lockfile_name = lockfile_name
        self.abs_lockfile = "%s/%s.lock" % (LOCKFILE_DIR, lockfile_name)
        self.mypid = str(os.getpid())
        self.lockfile_pid = 0

        try:
            self.fd = open(self.abs_lockfile, "r+")
            text = self.fd.read()
            self.lockfile_pid = string.strip(text)
        except IOError, e:
            ### File doesn't exist, so open it for write ###
            try:
                self.fd = open(self.abs_lockfile, "w")
            except IOError, e:
                msg = "%s" % e
                raise lockFileException(msg)

        try:
            fcntl.flock(self.fd, fcntl.LOCK_EX | fcntl.LOCK_NB)
        except IOError, e:
            raise lockFileException(_("Error: %s is already running under process %s, and has the configuration file locked") % (self.lockfile_text_name, self.lockfile_pid))

        self.fd.seek(0,0)
        self.fd.write(self.mypid + "\n")
        self.fd.flush()

    def releaseLock(self):
        try:
            self.fd.close()
            os.remove(self.abs_lockfile)
        except OSError, e:
            return FALSE
        return TRUE
        
